> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.solvimon.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.solvimon.com/_mcp/server.

# Get a list of events for provided filters

GET https://test.api.solvimon.com/v{version}/events

Requires the METER_DATA.VIEW permission.

Reference: https://docs.solvimon.com/api-docs/event-api/ingest/get-ingest-meter-data

## Authentication

- `X-API-KEY` header (required) — API Key authentication via header
- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://test.api.solvimon.com` (The TEST environment for our API, default)
- `https://api.solvimon.com` (The live environment for our API)

## Request

### Path parameters

- `version` (string, required, default: 1) — version

### Query parameters

- `customer_id` (string, optional) — The resource id of the customer.
- `reference` (string, optional) — The reference of the ingest.
- `meter_id` (string, optional) — The resource id of the meter.
- `deleted` (boolean, optional) — Filter the response by deleted field value.
- `processed_details_type` (string, optional) — Filter the response by processing_details.type value. Ex.: NOT_MATCHED, DUPLICATE
- `expand[]` (list of string, optional) — The id fields of the resources that are going to be expanded.
- `limit` (integer, optional) — The amount of records shown in the list
- `page` (integer, optional) — The page which is going to be shown

### Headers

- `x-platform-id` (string, optional) — Platform ID.

## Response

### 200

OK

- `data` (list of MeterData, required)
- `links` (PaginationLinks, required)
- `page` (integer, optional, nullable)
- `limit` (integer, optional, nullable)
- `total_number_of_pages` (integer, optional, nullable, deprecated)

## Errors

### 400 Bad Request Error

Bad Request

- `type` (enum, required)
  - Allowed values: `API_ERROR`, `INVALID_REQUEST`
- `code` (enum, required)
  - Allowed values: `RESOURCE_NOT_FOUND`, `RESOURCES_NOT_FOUND`, `UNABLE_TO_PROCESS_INSTRUCTIONS`, `BAD_REQUEST`, `UNSUPPORTED_MEDIA_TYPE`, `RESOURCE_ALREADY_EXISTS`, `CUSTOM_FIELD_VALUE_ALREADY_EXISTS`, `COULD_NOT_CREATE_RESOURCE`, `COULD_NOT_UPDATE_RESOURCE`, `COULD_NOT_DELETE_RESOURCE`, `MISSING_VERSION`, `UNSUPPORTED_VERSION`, `UNAUTHORISED`, `CUSTOMER_NOT_FOUND`, `PLATFORM_NOT_FOUND`, `PRICING_PLAN_NOT_FOUND`, `PRODUCT_NOT_FOUND`, `PRODUCT_ITEM_NOT_FOUND`, `PRICING_NOT_FOUND`, `PRICING_ITEM_NOT_FOUND`, `USER_NOT_FOUND`, `METER_NOT_FOUND`, `METER_VALUE_NOT_FOUND`, `METER_PROPERTY_NOT_FOUND`, `PRICING_ITEM_SUMMARIES_NOT_FOUND`, `MISSING_ID`, `INVALID_ID`, `MISSING_REFERENCE`, `MISSING_FIELD`, `INVALID_FIELD`, `INVALID_OPERATION`, `INTERNAL_ERROR`, `USER_NOT_ALLOWED`, `IDEMPOTENCY_CHECK_FAILED`, `INVALID_REQUEST`
- `message` (string, required)
- `field` (string, optional, nullable)
- `resource_id` (string, optional, nullable)
- `resource_type` (enum, optional, nullable)
  - Allowed values: `CUSTOMER`, `CUSTOM_FIELD`, `PLATFORM`, `PLATFORM_UPTODATE`, `METER`, `METER_VALUE`, `METER_PROPERTY`, `METER_PROPERTY_VARIABLE`, `METER_VALUE_CALCULATION`, `INGEST_DATA`, `METER_DATA`, `CHARGE_DATA`, `PERSIST_DATA`, `ADJUSTMENT_DATA`, `PRODUCT_CATEGORY`, `PRODUCT`, `PRODUCT_ITEM`, `PRICING`, `PRICING_GROUP`, `PRICING_ITEM`, `PRICING_ITEM_CONFIG`, `PRICING_PLAN_SUBSCRIPTION`, `PRICING_PLAN_SUBSCRIPTION_GROUP`, `PRICING_PLAN_SCHEDULE`, `SEAT_ASSIGNMENT`, `SHIPPING_ADDRESS`, `PRICING_PLAN`, `PRICING_PLAN_VERSION`, `PRICING_PLAN_GROUP`, `QUOTE`, `QUOTE_VERSION`, `QUOTE_TEMPLATE`, `QUOTE_VERSION_SUMMARY`, `API_KEY`, `USER`, `ROLE`, `PROXY_USER`, `EXTERNAL_CREDENTIALS`, `TOKEN`, `INVOICE`, `E_INVOICE`, `PDF`, `BILLING_ENTITY`, `FEATURE`, `MEMBERSHIP`, `PAYMENT`, `PAYMENT_ACCEPTOR`, `PAYMENT_METHOD`, `PAYMENT_METHOD_OPTIONS`, `PAYMENT_SCHEDULE`, `PAYMENT_REQUEST`, `INTEGRATION`, `WEBHOOK`, `WEBHOOK_EVENT`, `FILE`, `FILE_PROCESSING_SETTINGS`, `TEAM`, `DOWNLOAD_URL`, `CSV_REPORT`, `REPORT`, `REPORT_GENERATE_REQUEST`, `REPORT_CONFIGURATION`, `REPORT_SUBSCRIPTION`, `REPORT_DEFINITION`, `ACCOUNT_GROUP`, `ENTITY`, `EVENT_TRACE`, `EVENT_TRACE_LINK`, `PRICING_CATEGORY`, `CONTACT`, `ALERT_RULE`, `ALERT`, `USAGE_LIMIT`, `AUDIT_RECORD`, `PORTAL_URL`, `AUTHENTICATION_PROVIDER`, `REPROCESS`, `APPROVAL_POLICY`, `APPROVAL_REQUEST`, `BULK_ACTION`, `COUPON`, `PROMOTION_CODE`, `WALLET`, `WALLET_TYPE`, `WALLET_GRANT`, `AUTO_TOPUP_CONFIG`, `WORKFLOW`, `WORKFLOW_TRIGGER`, `WORKFLOW_ACTION`, `WORKFLOW_ACTION_EXECUTION`, `CREDIT_TYPE`, `SIGNATURE_REQUEST`, `ATTACHMENT`, `DOCUMENT`, `EXCHANGE_RATE`

### 401 Unauthorized Error

Unauthorized

- `type` (enum, required)
  - Allowed values: `API_ERROR`, `INVALID_REQUEST`
- `code` (enum, required)
  - Allowed values: `RESOURCE_NOT_FOUND`, `RESOURCES_NOT_FOUND`, `UNABLE_TO_PROCESS_INSTRUCTIONS`, `BAD_REQUEST`, `UNSUPPORTED_MEDIA_TYPE`, `RESOURCE_ALREADY_EXISTS`, `CUSTOM_FIELD_VALUE_ALREADY_EXISTS`, `COULD_NOT_CREATE_RESOURCE`, `COULD_NOT_UPDATE_RESOURCE`, `COULD_NOT_DELETE_RESOURCE`, `MISSING_VERSION`, `UNSUPPORTED_VERSION`, `UNAUTHORISED`, `CUSTOMER_NOT_FOUND`, `PLATFORM_NOT_FOUND`, `PRICING_PLAN_NOT_FOUND`, `PRODUCT_NOT_FOUND`, `PRODUCT_ITEM_NOT_FOUND`, `PRICING_NOT_FOUND`, `PRICING_ITEM_NOT_FOUND`, `USER_NOT_FOUND`, `METER_NOT_FOUND`, `METER_VALUE_NOT_FOUND`, `METER_PROPERTY_NOT_FOUND`, `PRICING_ITEM_SUMMARIES_NOT_FOUND`, `MISSING_ID`, `INVALID_ID`, `MISSING_REFERENCE`, `MISSING_FIELD`, `INVALID_FIELD`, `INVALID_OPERATION`, `INTERNAL_ERROR`, `USER_NOT_ALLOWED`, `IDEMPOTENCY_CHECK_FAILED`, `INVALID_REQUEST`
- `message` (string, required)
- `field` (string, optional, nullable)
- `resource_id` (string, optional, nullable)
- `resource_type` (enum, optional, nullable)
  - Allowed values: `CUSTOMER`, `CUSTOM_FIELD`, `PLATFORM`, `PLATFORM_UPTODATE`, `METER`, `METER_VALUE`, `METER_PROPERTY`, `METER_PROPERTY_VARIABLE`, `METER_VALUE_CALCULATION`, `INGEST_DATA`, `METER_DATA`, `CHARGE_DATA`, `PERSIST_DATA`, `ADJUSTMENT_DATA`, `PRODUCT_CATEGORY`, `PRODUCT`, `PRODUCT_ITEM`, `PRICING`, `PRICING_GROUP`, `PRICING_ITEM`, `PRICING_ITEM_CONFIG`, `PRICING_PLAN_SUBSCRIPTION`, `PRICING_PLAN_SUBSCRIPTION_GROUP`, `PRICING_PLAN_SCHEDULE`, `SEAT_ASSIGNMENT`, `SHIPPING_ADDRESS`, `PRICING_PLAN`, `PRICING_PLAN_VERSION`, `PRICING_PLAN_GROUP`, `QUOTE`, `QUOTE_VERSION`, `QUOTE_TEMPLATE`, `QUOTE_VERSION_SUMMARY`, `API_KEY`, `USER`, `ROLE`, `PROXY_USER`, `EXTERNAL_CREDENTIALS`, `TOKEN`, `INVOICE`, `E_INVOICE`, `PDF`, `BILLING_ENTITY`, `FEATURE`, `MEMBERSHIP`, `PAYMENT`, `PAYMENT_ACCEPTOR`, `PAYMENT_METHOD`, `PAYMENT_METHOD_OPTIONS`, `PAYMENT_SCHEDULE`, `PAYMENT_REQUEST`, `INTEGRATION`, `WEBHOOK`, `WEBHOOK_EVENT`, `FILE`, `FILE_PROCESSING_SETTINGS`, `TEAM`, `DOWNLOAD_URL`, `CSV_REPORT`, `REPORT`, `REPORT_GENERATE_REQUEST`, `REPORT_CONFIGURATION`, `REPORT_SUBSCRIPTION`, `REPORT_DEFINITION`, `ACCOUNT_GROUP`, `ENTITY`, `EVENT_TRACE`, `EVENT_TRACE_LINK`, `PRICING_CATEGORY`, `CONTACT`, `ALERT_RULE`, `ALERT`, `USAGE_LIMIT`, `AUDIT_RECORD`, `PORTAL_URL`, `AUTHENTICATION_PROVIDER`, `REPROCESS`, `APPROVAL_POLICY`, `APPROVAL_REQUEST`, `BULK_ACTION`, `COUPON`, `PROMOTION_CODE`, `WALLET`, `WALLET_TYPE`, `WALLET_GRANT`, `AUTO_TOPUP_CONFIG`, `WORKFLOW`, `WORKFLOW_TRIGGER`, `WORKFLOW_ACTION`, `WORKFLOW_ACTION_EXECUTION`, `CREDIT_TYPE`, `SIGNATURE_REQUEST`, `ATTACHMENT`, `DOCUMENT`, `EXCHANGE_RATE`

### 403 Forbidden Error

Forbidden

- `type` (enum, required)
  - Allowed values: `API_ERROR`, `INVALID_REQUEST`
- `code` (enum, required)
  - Allowed values: `RESOURCE_NOT_FOUND`, `RESOURCES_NOT_FOUND`, `UNABLE_TO_PROCESS_INSTRUCTIONS`, `BAD_REQUEST`, `UNSUPPORTED_MEDIA_TYPE`, `RESOURCE_ALREADY_EXISTS`, `CUSTOM_FIELD_VALUE_ALREADY_EXISTS`, `COULD_NOT_CREATE_RESOURCE`, `COULD_NOT_UPDATE_RESOURCE`, `COULD_NOT_DELETE_RESOURCE`, `MISSING_VERSION`, `UNSUPPORTED_VERSION`, `UNAUTHORISED`, `CUSTOMER_NOT_FOUND`, `PLATFORM_NOT_FOUND`, `PRICING_PLAN_NOT_FOUND`, `PRODUCT_NOT_FOUND`, `PRODUCT_ITEM_NOT_FOUND`, `PRICING_NOT_FOUND`, `PRICING_ITEM_NOT_FOUND`, `USER_NOT_FOUND`, `METER_NOT_FOUND`, `METER_VALUE_NOT_FOUND`, `METER_PROPERTY_NOT_FOUND`, `PRICING_ITEM_SUMMARIES_NOT_FOUND`, `MISSING_ID`, `INVALID_ID`, `MISSING_REFERENCE`, `MISSING_FIELD`, `INVALID_FIELD`, `INVALID_OPERATION`, `INTERNAL_ERROR`, `USER_NOT_ALLOWED`, `IDEMPOTENCY_CHECK_FAILED`, `INVALID_REQUEST`
- `message` (string, required)
- `field` (string, optional, nullable)
- `resource_id` (string, optional, nullable)
- `resource_type` (enum, optional, nullable)
  - Allowed values: `CUSTOMER`, `CUSTOM_FIELD`, `PLATFORM`, `PLATFORM_UPTODATE`, `METER`, `METER_VALUE`, `METER_PROPERTY`, `METER_PROPERTY_VARIABLE`, `METER_VALUE_CALCULATION`, `INGEST_DATA`, `METER_DATA`, `CHARGE_DATA`, `PERSIST_DATA`, `ADJUSTMENT_DATA`, `PRODUCT_CATEGORY`, `PRODUCT`, `PRODUCT_ITEM`, `PRICING`, `PRICING_GROUP`, `PRICING_ITEM`, `PRICING_ITEM_CONFIG`, `PRICING_PLAN_SUBSCRIPTION`, `PRICING_PLAN_SUBSCRIPTION_GROUP`, `PRICING_PLAN_SCHEDULE`, `SEAT_ASSIGNMENT`, `SHIPPING_ADDRESS`, `PRICING_PLAN`, `PRICING_PLAN_VERSION`, `PRICING_PLAN_GROUP`, `QUOTE`, `QUOTE_VERSION`, `QUOTE_TEMPLATE`, `QUOTE_VERSION_SUMMARY`, `API_KEY`, `USER`, `ROLE`, `PROXY_USER`, `EXTERNAL_CREDENTIALS`, `TOKEN`, `INVOICE`, `E_INVOICE`, `PDF`, `BILLING_ENTITY`, `FEATURE`, `MEMBERSHIP`, `PAYMENT`, `PAYMENT_ACCEPTOR`, `PAYMENT_METHOD`, `PAYMENT_METHOD_OPTIONS`, `PAYMENT_SCHEDULE`, `PAYMENT_REQUEST`, `INTEGRATION`, `WEBHOOK`, `WEBHOOK_EVENT`, `FILE`, `FILE_PROCESSING_SETTINGS`, `TEAM`, `DOWNLOAD_URL`, `CSV_REPORT`, `REPORT`, `REPORT_GENERATE_REQUEST`, `REPORT_CONFIGURATION`, `REPORT_SUBSCRIPTION`, `REPORT_DEFINITION`, `ACCOUNT_GROUP`, `ENTITY`, `EVENT_TRACE`, `EVENT_TRACE_LINK`, `PRICING_CATEGORY`, `CONTACT`, `ALERT_RULE`, `ALERT`, `USAGE_LIMIT`, `AUDIT_RECORD`, `PORTAL_URL`, `AUTHENTICATION_PROVIDER`, `REPROCESS`, `APPROVAL_POLICY`, `APPROVAL_REQUEST`, `BULK_ACTION`, `COUPON`, `PROMOTION_CODE`, `WALLET`, `WALLET_TYPE`, `WALLET_GRANT`, `AUTO_TOPUP_CONFIG`, `WORKFLOW`, `WORKFLOW_TRIGGER`, `WORKFLOW_ACTION`, `WORKFLOW_ACTION_EXECUTION`, `CREDIT_TYPE`, `SIGNATURE_REQUEST`, `ATTACHMENT`, `DOCUMENT`, `EXCHANGE_RATE`

### 500 Internal Server Error

Internal Server Error

- `type` (enum, required)
  - Allowed values: `API_ERROR`, `INVALID_REQUEST`
- `code` (enum, required)
  - Allowed values: `RESOURCE_NOT_FOUND`, `RESOURCES_NOT_FOUND`, `UNABLE_TO_PROCESS_INSTRUCTIONS`, `BAD_REQUEST`, `UNSUPPORTED_MEDIA_TYPE`, `RESOURCE_ALREADY_EXISTS`, `CUSTOM_FIELD_VALUE_ALREADY_EXISTS`, `COULD_NOT_CREATE_RESOURCE`, `COULD_NOT_UPDATE_RESOURCE`, `COULD_NOT_DELETE_RESOURCE`, `MISSING_VERSION`, `UNSUPPORTED_VERSION`, `UNAUTHORISED`, `CUSTOMER_NOT_FOUND`, `PLATFORM_NOT_FOUND`, `PRICING_PLAN_NOT_FOUND`, `PRODUCT_NOT_FOUND`, `PRODUCT_ITEM_NOT_FOUND`, `PRICING_NOT_FOUND`, `PRICING_ITEM_NOT_FOUND`, `USER_NOT_FOUND`, `METER_NOT_FOUND`, `METER_VALUE_NOT_FOUND`, `METER_PROPERTY_NOT_FOUND`, `PRICING_ITEM_SUMMARIES_NOT_FOUND`, `MISSING_ID`, `INVALID_ID`, `MISSING_REFERENCE`, `MISSING_FIELD`, `INVALID_FIELD`, `INVALID_OPERATION`, `INTERNAL_ERROR`, `USER_NOT_ALLOWED`, `IDEMPOTENCY_CHECK_FAILED`, `INVALID_REQUEST`
- `message` (string, required)
- `field` (string, optional, nullable)
- `resource_id` (string, optional, nullable)
- `resource_type` (enum, optional, nullable)
  - Allowed values: `CUSTOMER`, `CUSTOM_FIELD`, `PLATFORM`, `PLATFORM_UPTODATE`, `METER`, `METER_VALUE`, `METER_PROPERTY`, `METER_PROPERTY_VARIABLE`, `METER_VALUE_CALCULATION`, `INGEST_DATA`, `METER_DATA`, `CHARGE_DATA`, `PERSIST_DATA`, `ADJUSTMENT_DATA`, `PRODUCT_CATEGORY`, `PRODUCT`, `PRODUCT_ITEM`, `PRICING`, `PRICING_GROUP`, `PRICING_ITEM`, `PRICING_ITEM_CONFIG`, `PRICING_PLAN_SUBSCRIPTION`, `PRICING_PLAN_SUBSCRIPTION_GROUP`, `PRICING_PLAN_SCHEDULE`, `SEAT_ASSIGNMENT`, `SHIPPING_ADDRESS`, `PRICING_PLAN`, `PRICING_PLAN_VERSION`, `PRICING_PLAN_GROUP`, `QUOTE`, `QUOTE_VERSION`, `QUOTE_TEMPLATE`, `QUOTE_VERSION_SUMMARY`, `API_KEY`, `USER`, `ROLE`, `PROXY_USER`, `EXTERNAL_CREDENTIALS`, `TOKEN`, `INVOICE`, `E_INVOICE`, `PDF`, `BILLING_ENTITY`, `FEATURE`, `MEMBERSHIP`, `PAYMENT`, `PAYMENT_ACCEPTOR`, `PAYMENT_METHOD`, `PAYMENT_METHOD_OPTIONS`, `PAYMENT_SCHEDULE`, `PAYMENT_REQUEST`, `INTEGRATION`, `WEBHOOK`, `WEBHOOK_EVENT`, `FILE`, `FILE_PROCESSING_SETTINGS`, `TEAM`, `DOWNLOAD_URL`, `CSV_REPORT`, `REPORT`, `REPORT_GENERATE_REQUEST`, `REPORT_CONFIGURATION`, `REPORT_SUBSCRIPTION`, `REPORT_DEFINITION`, `ACCOUNT_GROUP`, `ENTITY`, `EVENT_TRACE`, `EVENT_TRACE_LINK`, `PRICING_CATEGORY`, `CONTACT`, `ALERT_RULE`, `ALERT`, `USAGE_LIMIT`, `AUDIT_RECORD`, `PORTAL_URL`, `AUTHENTICATION_PROVIDER`, `REPROCESS`, `APPROVAL_POLICY`, `APPROVAL_REQUEST`, `BULK_ACTION`, `COUPON`, `PROMOTION_CODE`, `WALLET`, `WALLET_TYPE`, `WALLET_GRANT`, `AUTO_TOPUP_CONFIG`, `WORKFLOW`, `WORKFLOW_TRIGGER`, `WORKFLOW_ACTION`, `WORKFLOW_ACTION_EXECUTION`, `CREDIT_TYPE`, `SIGNATURE_REQUEST`, `ATTACHMENT`, `DOCUMENT`, `EXCHANGE_RATE`

## Types

### MeterData

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional, nullable)
- `type` (enum, optional, nullable) — The type of meter data.
  - Allowed values: `INGEST`, `CALCULATION`
- `customer_id` (string, optional, nullable) — The resource ID of the associated customer.
- `customer_reference` (string, optional, nullable) — A custom reference assigned to the customer.
- `customer` (Customer, optional, nullable)
- `meter_id` (string, optional, nullable) — The resource ID of the meter.
- `meter_reference` (string, optional, nullable) — A custom reference assigned to the meter.
- `pricing_plan_subscription_id` (string, optional, nullable) — The resource ID of the associated pricing plan subscription.
- `pricing_plan_subscription_reference` (string, optional, nullable) — A custom reference assigned to the pricing plan subscription.
- `pricing_plan_subscription_selector` (PricingPlanSubscriptionSelector, optional) — A selector to dynamically determine the subscription to use.
- `timestamp` (datetime, optional, nullable) — The associated timestamp presented in the ISO 8601 standard of the charge event, if not provided it will be set to 'now'.
- `created_at` (string, optional, nullable) — The associated timestamp presented in the ISO 8601 standard of the creation of the event in Solvimon.
- `meter_properties` (list of MeterDataMeterProperty, optional, nullable) — The properties that provide information to give context to an event, used in the meter.
- `meter_values` (list of MeterDataMeterValue, optional, nullable) — The values used as input to calculate billable units, used in the meter.
- `cost_prediction` (CostPrediction, optional, nullable) — The cost prediction.
- `processed_details` (MeterDataProcessedDetails, optional, nullable) — Details of the result of processing the event.
- `deleted` (boolean, optional, nullable) — Is MeterData marked as deleted.

### PaginationLinks

- `first` (string, optional, nullable)
- `previous` (string, optional, nullable)
- `current` (string, optional, nullable)
- `next` (string, optional, nullable)

### Customer

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `created_at` (string, optional, nullable)
- `parent_customer_id` (string, optional, nullable) — The parent of the customer. Only returned when there is a single parent.
- `parent_customer_ids` (list of string, optional, nullable) — A list of parents of the customer. Will also be returned if there is a single parent.
- `reference` (string, optional) — A custom reference assigned to the customer.
- `status` (enum, optional, nullable)
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`, `CLOSED`
- `timezone` (string, optional, nullable)
- `type` (enum, optional) — The type of customer entity.
  - Allowed values: `ORGANIZATION`, `INDIVIDUAL`
- `email` (string, optional, nullable) — The email of the customer.
- `notification_preferences` (list of NotificationPreference, optional, nullable) — Notification preferences for customer-related communications.
- `locale` (string, optional, nullable) — The locale of the customer. Format is language-country (like en-US).
- `individual` (Individual, optional) — Additional description of the individual customer type.
- `organization` (Organization, optional) — Additional description of the organization customer type.
- `custom_fields` (list of CustomFieldValue, optional, nullable)
- `pricing_plan_subscription_selector` (PricingPlanSubscriptionSelector, optional) — Settings to influence dynamically the subscription to use for the ingest data.
- `linked_integrations` (list of LinkedIntegration, optional, nullable)
- `roles` (list of enum, optional, nullable)
  - Allowed values: `DEFAULT`, `NON_PROCESSING`, `SELF_BILLING`, `SELLER`, `PROCESSING_ONLY`
- `seller_details` (CustomerSellerDetails, optional)
- `processing_only` (boolean, optional, nullable, deprecated)

### PricingPlanSubscriptionSelector

- `data` (list of PricingPlanSubscriptionSelectorData, optional, nullable)
- `rules` (list of PricingPlanSubscriptionSelectorRule, optional, nullable)
- `filters` (list of PricingPlanSubscriptionSelectorFilter, optional, nullable)
- `fallback` (enum, optional, nullable) — The fallback logic what to do when no subscription is found. By default it is LATEST
  - Allowed values: `LATEST`, `NONE`

### MeterDataMeterProperty

- `id` (string, optional, nullable) — Resource ID of type METER_PROPERTY
- `reference` (string, optional, nullable)
- `value` (string, optional, nullable)
- `dynamic_validation_settings` (MeterPropertyDynamicValidationSettings, optional) — Optional validation settings in case the event; used only when a meter property is created on the fly during DYNAMIC ingest.

### MeterDataMeterValue

- `id` (string, optional, nullable) — Resource ID of type METER_VALUE
- `reference` (string, optional, nullable)
- `number` (string, optional, nullable)
- `amount` (Amount, optional)
- `count` (string, optional, nullable)
- `dynamic_validation_settings` (MeterValueDynamicValidationSettings, optional) — Optional validation settings; used only when a meter value is created on the fly during DYNAMIC ingest.

### CostPrediction

- `response` (enum, optional)
  - Allowed values: `OK`, `FAILED`, `NOT_SUPPORTED`
- `status` (enum, optional)
  - Allowed values: `READY`, `PENDING`, `ERROR`, `DUPLICATE`, `NOT_MATCHED`
- `details` (list of CostPredictionDetails, optional, nullable)
- `used_change_rates` (list of UsedExchangeRate, optional, nullable)

### MeterDataProcessedDetails

- `type` (enum, optional, nullable)
  - Allowed values: `DEFAULT`, `NOT_MATCHED`, `DUPLICATE`
- `duplicate` (Duplicate, optional, nullable)
- `not_matched` (NotMatched, optional, nullable)
- `duplicate_of_meter_data_id` (string, optional, nullable, deprecated)

### NotificationPreference

- `type` (enum, optional) — The notification type to configure.
  - Allowed values: `INVOICE`
- `channels` (list of NotificationChannel, optional, nullable) — The channels for this notification type.

### Individual

- `name` (Name, optional)
- `residential_address` (Address, optional)

### Organization

- `legal_name` (string, optional)
- `tax_id` (string, optional, nullable) — Tax Id used for tax purposes of the organization
- `tax_ids` (list of TaxId, optional, nullable) — Tax Ids used for tax purposes of the organization
- `registration_number` (string, optional, nullable)
- `tax_exempt` (boolean, optional, nullable)
- `tax_exempt_note` (string, optional, nullable)
- `registered_address` (Address, optional)
- `tax_registrations` (list of TaxRegistration, optional, nullable) — Extra tax registrations for the customer

### CustomFieldValue

- `id` (string, optional, nullable) — Resource ID of type CUSTOM_FIELD
- `reference` (string, optional, nullable)
- `value` (string, optional, nullable)
- `values` (list of string, optional, nullable)
- `integration_details` (IntegrationDetails, optional, nullable)
- `integration_id` (string, optional) — The resource ID of the integration linked to the custom field

### LinkedIntegration

- `id` (string, optional)
- `link_details` (list of LinkDetail, optional)

### CustomerSellerDetails

- `default_billing_entity_id` (string, optional, nullable) — Resource ID of type BILLING_ENTITY

### PricingPlanSubscriptionSelectorData

- `field` (enum, optional)
  - Allowed values: `BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY`, `PRICING_PLAN_REFERENCE`
- `value` (string, optional)

### PricingPlanSubscriptionSelectorRule

- `field` (enum, optional)
  - Allowed values: `BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY`, `PRICING_PLAN_REFERENCE`
- `type` (enum, optional)
  - Allowed values: `EQUALS`, `NOT_EQUALS`, `IN`, `NOT_IN`, `GREATER_THAN`, `GREATER_THAN_OR_EQUALS`, `LESS_THAN`, `LESS_THAN_OR_EQUALS`, `EMPTY`, `NOT_EMPTY`, `CONTAINS`, `NOT_CONTAINS`

### PricingPlanSubscriptionSelectorFilter

- `field` (enum, optional)
  - Allowed values: `BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY`, `PRICING_PLAN_REFERENCE`
- `type` (enum, optional)
  - Allowed values: `EQUALS`, `NOT_EQUALS`, `IN`, `NOT_IN`, `GREATER_THAN`, `GREATER_THAN_OR_EQUALS`, `LESS_THAN`, `LESS_THAN_OR_EQUALS`, `EMPTY`, `NOT_EMPTY`, `CONTAINS`, `NOT_CONTAINS`
- `value` (string, optional)

### MeterPropertyDynamicValidationSettings

- `type` (enum, optional, nullable) — Optional type. When omitted, the property is created as STRING. Ignored if the meter property already exists.
  - Allowed values: `NUMBER`, `ENUM`, `STRING`
- `required` (boolean, optional, nullable)

### Amount

- `quantity` (string, optional)
- `currency` (enum, optional)
  - Allowed values: `AED`, `AFN`, `ALL`, `AMD`, `ANG`, `AOA`, `ARS`, `AUD`, `AWG`, `AZN`, `BAM`, `BBD`, `BDT`, `BGN`, `BHD`, `BIF`, `BMD`, `BND`, `BOB`, `BRL`, `BSD`, `BTN`, `BWP`, `BYN`, `BZD`, `CAD`, `CDF`, `CHF`, `CLF`, `CLP`, `CNY`, `COP`, `CRC`, `CUC`, `CUP`, `CVE`, `CZK`, `DJF`, `DKK`, `DOP`, `DZD`, `EGP`, `ERN`, `ETB`, `EUR`, `FJD`, `FKP`, `GBP`, `GEL`, `GHS`, `GIP`, `GMD`, `GNF`, `GTQ`, `GYD`, `HKD`, `HNL`, `HRK`, `HTG`, `HUF`, `IDR`, `ILS`, `INR`, `IQD`, `IRR`, `ISK`, `JMD`, `JOD`, `JPY`, `KES`, `KGS`, `KHR`, `KMF`, `KPW`, `KRW`, `KWD`, `KYD`, `KZT`, `LAK`, `LBP`, `LKR`, `LRD`, `LSL`, `LYD`, `MAD`, `MDL`, `MGA`, `MKD`, `MMK`, `MNT`, `MOP`, `MRO`, `MRU`, `MUR`, `MVR`, `MWK`, `MXN`, `MXV`, `MYR`, `MZN`, `NAD`, `NGN`, `NIO`, `NOK`, `NPR`, `NZD`, `OMR`, `PAB`, `PEN`, `PGK`, `PHP`, `PKR`, `PLN`, `PYG`, `QAR`, `RON`, `RSD`, `RUB`, `RWF`, `SAR`, `SBD`, `SCR`, `SDG`, `SEK`, `SGD`, `SHP`, `SLE`, `SOS`, `SRD`, `SSP`, `STN`, `SVC`, `SYP`, `SZL`, `THB`, `TJS`, `TMT`, `TND`, `TOP`, `TRY`, `TTD`, `TWD`, `TZS`, `UAH`, `UGX`, `USD`, `USN`, `UYI`, `UYU`, `UZS`, `VEF`, `VES`, `VND`, `VUV`, `WST`, `XAF`, `XAG`, `XAU`, `XBA`, `XBB`, `XBC`, `XBD`, `XCD`, `XDR`, `XOF`, `XPD`, `XPF`, `XPT`, `XSU`, `XTS`, `XUA`, `XXX`, `YER`, `ZAR`, `ZMW`, `ZWL`

### MeterValueDynamicValidationSettings

- `type` (enum, optional, nullable) — Optional type. When omitted, the type is derived from the submitted value (an amount implies AMOUNT, otherwise NUMBER). Ignored if the meter value already exists.
  - Allowed values: `NUMBER`, `AMOUNT`
- `required` (boolean, optional, nullable)

### CostPredictionDetails

- `customer_id` (string, optional)
- `invoice_id` (string, optional, nullable)
- `amount_excluding_tax` (Amount, optional)
- `amount_including_tax` (Amount, optional)
- `tax_summary` (InvoiceTaxTotalSummary, optional)
- `periods` (list of InvoicePeriod, optional)
- `pre_wallet_balance` (CustomerWalletBalanceStatus, optional)
- `post_wallet_balance` (CustomerWalletBalanceStatus, optional)

### UsedExchangeRate

- `currency` (string, optional)
- `base_currency` (string, optional)
- `rate_timestamp` (string, optional)
- `rate` (string, optional)
- `source` (string, optional, nullable)

### Duplicate

- `of_meter_data_id` (string, optional, nullable)

### NotMatched

- `variant` (string, optional, nullable)

### NotificationChannel

- `type` (enum, optional) — The channel type to use.
  - Allowed values: `EMAIL`
- `enabled` (boolean, optional, nullable) — Whether the channel is enabled for the notification type.

### Name

- `first_name` (string, optional, nullable)
- `last_name` (string, optional, nullable)
- `infix` (string, optional, nullable)

### Address

- `line1` (string, optional, nullable)
- `line2` (string, optional, nullable)
- `city` (string, optional, nullable)
- `postal_code` (string, optional, nullable)
- `state` (string, optional, nullable)
- `country` (enum, optional, nullable)
  - Allowed values: `AD`, `AE`, `AF`, `AG`, `AI`, `AL`, `AM`, `AO`, `AQ`, `AR`, `AS`, `AT`, `AU`, `AW`, `AX`, `AZ`, `BA`, `BB`, `BD`, `BE`, `BF`, `BG`, `BH`, `BI`, `BJ`, `BL`, `BM`, `BN`, `BO`, `BQ`, `BR`, `BS`, `BT`, `BV`, `BW`, `BY`, `BZ`, `CA`, `CC`, `CD`, `CF`, `CG`, `CH`, `CI`, `CK`, `CL`, `CM`, `CN`, `CO`, `CR`, `CU`, `CV`, `CW`, `CX`, `CY`, `CZ`, `DE`, `DJ`, `DK`, `DM`, `DO`, `DZ`, `EC`, `EE`, `EG`, `EH`, `ER`, `ES`, `ET`, `FI`, `FJ`, `FK`, `FM`, `FO`, `FR`, `GA`, `GB`, `GD`, `GE`, `GF`, `GG`, `GH`, `GI`, `GL`, `GM`, `GN`, `GP`, `GQ`, `GR`, `GS`, `GT`, `GU`, `GW`, `GY`, `HK`, `HM`, `HN`, `HR`, `HT`, `HU`, `ID`, `IE`, `IL`, `IM`, `IN`, `IO`, `IQ`, `IR`, `IS`, `IT`, `JE`, `JM`, `JO`, `JP`, `KE`, `KG`, `KH`, `KI`, `KM`, `KN`, `KP`, `KR`, `KW`, `KY`, `KZ`, `LA`, `LB`, `LC`, `LI`, `LK`, `LR`, `LS`, `LT`, `LU`, `LV`, `LY`, `MA`, `MC`, `MD`, `ME`, `MF`, `MG`, `MH`, `MK`, `ML`, `MM`, `MN`, `MO`, `MP`, `MQ`, `MR`, `MS`, `MT`, `MU`, `MV`, `MW`, `MX`, `MY`, `MZ`, `NA`, `NC`, `NE`, `NF`, `NG`, `NI`, `NL`, `NO`, `NP`, `NR`, `NU`, `NZ`, `OM`, `PA`, `PE`, `PF`, `PG`, `PH`, `PK`, `PL`, `PM`, `PN`, `PR`, `PS`, `PT`, `PW`, `PY`, `QA`, `RE`, `RO`, `RS`, `RU`, `RW`, `SA`, `SB`, `SC`, `SD`, `SE`, `SG`, `SH`, `SI`, `SJ`, `SK`, `SL`, `SM`, `SN`, `SO`, `SR`, `SS`, `ST`, `SV`, `SX`, `SY`, `SZ`, `TC`, `TD`, `TF`, `TG`, `TH`, `TJ`, `TK`, `TL`, `TM`, `TN`, `TO`, `TR`, `TT`, `TV`, `TW`, `TZ`, `UA`, `UG`, `US`, `UY`, `UZ`, `VA`, `VC`, `VE`, `VG`, `VI`, `VN`, `VU`, `WF`, `WS`, `YE`, `YT`, `ZA`, `ZM`, `ZW`

### TaxId

- `id` (string, optional)
- `type` (enum, optional, nullable) — Optional tax id type, indicates which type of tax the number is for
  - Allowed values: `GENERIC_TAX_ID`, `AU_GST`, `CA_GST_HST`, `CA_PST`, `CA_PST_BC`, `CA_PST_MB`, `CA_PST_SK`, `CA_QST`
- `display_name` (string, optional, nullable) — User-friendly display name
- `tax_id_validation_result` (TaxIdValidation, optional)

### TaxRegistration

- `id` (string, optional, nullable) — The id of this tax registration
- `description` (string, optional, nullable) — The description of this tax registration
- `tax_id` (string, optional, nullable) — The tax id of this tax registration, e.g. a TIN, VAT id or other tax number
- `tax_ids` (list of TaxId, optional, nullable) — Tax IDs used for tax purposes of the tax registration, e.g. TINs, VAT ids, or other tax number
- `registration_number` (string, optional, nullable) — The registration number of this tax registration, e.g. a company registration number
- `registered_address` (Address, optional) — The address of this tax registration, if different from the billing entity. Currently, only the address will be used for tax calculations

### IntegrationDetails

- `id` (string, optional, nullable)
- `reference` (string, optional, nullable)
- `payment_gateway_variant` (enum, optional)
  - Allowed values: `ADYEN`, `STRIPE`
- `adyen` (AdyenIntegrationDetails, optional)
- `stripe` (StripeIntegrationDetails, optional)

### LinkDetail

- `url` (string, optional, nullable)
- `custom_field_name` (string, optional, nullable)

### InvoiceTaxTotalSummary

- `base_amount` (Amount, optional)
- `tax_amount` (Amount, optional)
- `total_amount` (Amount, optional)
- `local_amounts` (InvoiceTaxAmounts, optional)
- `notes` (list of string, optional, nullable)
- `country_code` (string, optional)

### InvoicePeriod

- `period_order` (integer, optional)
- `amount_excluding_tax` (Amount, optional)
- `amount_including_tax` (Amount, optional)
- `billing_period` (Period, optional)
- `start_at` (string, optional)
- `end_at` (string, optional)
- `tax_categories` (list of InvoiceTaxCategorySummary, optional)
- `groups` (list of InvoiceGroup, optional, nullable)

### CustomerWalletBalanceStatus

- `wallet_id` (string, optional, nullable)
- `wallet` (Wallet, optional, nullable)
- `wallet_balance` (WalletBalanceStatus, optional, nullable)
- `charge_on_demand_pricing_items` (list of ChargeOnDemandPricingItem, optional, nullable)

### TaxIdValidation

- `id` (string, optional)
- `validation_date` (string, optional)
- `source` (string, optional)
- `valid` (enum, optional)
  - Allowed values: `VALID`, `NOT_VALID`, `UNKNOWN`
- `message` (string, optional, nullable)

### AdyenIntegrationDetails

- `recurring_detail_reference` (string, optional)

### StripeIntegrationDetails

- `payment_method_id` (string, optional)

### InvoiceTaxAmounts

- `base_amount` (Amount, optional)
- `tax_amount` (Amount, optional)
- `total_amount` (Amount, optional)
- `used_exchange_rate` (UsedExchangeRate, optional)
- `display` (boolean, optional)

### Period

- `type` (enum, optional)
  - Allowed values: `DAY`, `WEEK`, `MONTH`, `YEAR`
- `value` (integer, optional, nullable)

### InvoiceTaxCategorySummary

- `base_amount` (Amount, optional)
- `tax_amount` (Amount, optional)
- `total_amount` (Amount, optional)
- `category` (string, optional)
- `local_amounts` (InvoiceTaxAmounts, optional)
- `notes` (list of string, optional, nullable)
- `rates` (list of InvoiceTaxCategorySummaryRate, optional, nullable)
- `percentage` (string, optional, deprecated)
- `name` (string, optional, deprecated)

### InvoiceGroup

- `group_order` (integer, optional)
- `amount_excluding_tax` (Amount, optional)
- `amount_including_tax` (Amount, optional)
- `billing_period` (Period, optional, nullable)
- `start_at` (string, optional, nullable)
- `end_at` (string, optional, nullable)
- `type` (string, optional, nullable)
- `product_category` (ProductCategory, optional, nullable)
- `products` (list of Product, optional, nullable)
- `pricing` (InvoicePricing, optional, nullable)
- `description` (string, optional, nullable)
- `pricing_plan_subscription_id` (string, optional, nullable)
- `pricing_plan_schedule_id` (string, optional, nullable)
- `forwarded_from_customer_id` (string, optional, nullable)
- `tax_categories` (list of InvoiceTaxCategorySummary, optional)
- `lines` (list of InvoiceLine, optional, nullable)
- `billing_customer_id` (string, optional, nullable, deprecated)

### Wallet

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `status` (enum, optional, nullable)
  - Allowed values: `DRAFT`, `ACTIVE`, `INACTIVE`, `DEPRECATED`, `ARCHIVED`
- `wallet_type_id` (string, optional) — Resource ID of type WALLET_TYPE
- `wallet_type` (WalletType, optional, nullable)
- `auto_top_up_configs` (list of AutoTopupConfig, optional, nullable)
- `customer_id` (string, optional) — Resource ID of type CUSTOMER
- `created_at` (string, optional, nullable)
- `updated_at` (string, optional, nullable)

### WalletBalanceStatus

- `balance` (WalletBalanceValue, optional, nullable)
- `reserved_balance` (WalletBalanceValue, optional, nullable)
- `open_balance` (WalletBalanceValue, optional, nullable)
- `balance_at` (string, optional, nullable)
- `over_granted` (WalletBalanceValue, optional, nullable) — The part of this balance the periods behind it were not entitled to.
- `customer_details` (list of WalletCustomerBalanceDetail, optional, nullable) — The reserved balance split over the customers whose usage produced it, requested with `include_customer_details`. Stored when an invoice is built/ refreshed.

### ChargeOnDemandPricingItem

- `pricing_item_id` (string, optional, nullable)
- `pricing_plan_schedule_id` (string, optional, nullable)
- `pricing_item` (PricingItem, optional, nullable)

### InvoiceTaxCategorySummaryRate

- `name` (string, optional)
- `percentage` (string, optional)
- `tax_amount` (Amount, optional)

### ProductCategory

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `name` (string, optional)
- `reference` (string, optional)
- `description` (string, optional, nullable)
- `tax_category` (enum, optional, nullable) — The default tax category applied to the products in the product category.
  - Allowed values: `STANDARD`, `NO_TAX`, `EXEMPT`
- `display_order` (integer, optional, nullable)
- `customer_id` (string, optional, nullable) — Resource ID of type CUSTOMER

### Product

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `category_id` (string, optional) — The resource ID of the product category, that belongs to the product.
- `category` (ProductCategory, optional, nullable)
- `parent_product_id` (string, optional, nullable) — The resource ID of the original product, to which the product will belong to.
- `name` (string, optional)
- `reference` (string, optional)
- `description` (string, optional, nullable)
- `status` (enum, optional, nullable) — The status of the product.
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`
- `product_type` (enum, optional)
  - Allowed values: `DEFAULT`, `ADDON`
- `tax_category` (enum, optional, nullable) — The default tax category applied to the product.
  - Allowed values: `STANDARD`, `NO_TAX`, `EXEMPT`
- `features` (list of FeatureResourceReference, optional, nullable) — The features associated with the product.
- `custom_fields` (list of CustomFieldValue, optional, nullable)
- `display_order` (integer, optional, nullable) — Determines the order in which products are displayed on overview pages and invoices. The lowest number gets the highest priority.
- `linked_integrations` (list of LinkedIntegration, optional, nullable)
- `billing_entity_id` (string, optional, nullable) — The resource ID of the billing entity linked to this product.
- `customer_id` (string, optional, nullable)
- `agent_context` (AgentContext, optional) — Context for AI agents about this product. Intended for agents, not for customer-facing output.

### InvoicePricing

- `id` (string, optional)
- `name` (string, optional)

### InvoiceLine

- `id` (string, optional, nullable)
- `line_order` (integer, optional, nullable)
- `description` (string, optional, nullable)
- `pricing_item_id` (string, optional, nullable)
- `pricing_item_config_id` (string, optional, nullable)
- `product_items` (list of ProductItem, optional, nullable)
- `type` (string, optional, nullable)
- `pricing_type` (string, optional, nullable) — The type of pricing that is applicable for this line, this value is set when type == REVENUE
- `commitment_type` (string, optional, nullable) — The type of commitment that is applicable for this line, this value is set when type == COMMITMENT
- `discount_type` (string, optional, nullable) — The type of discount that is applicable for this line, this value is set when type == DISCOUNT
- `coupon_data` (InvoiceLineCouponData, optional, nullable) — References to the coupon and promotion code, this value is optionally set when type == DISCOUNT and the discount was applied through a coupon or promo code
- `tax_categories` (list of InvoiceTaxCategorySummary, optional, nullable)
- `amount_excluding_tax` (Amount, optional, nullable)
- `amount_including_tax` (Amount, optional, nullable)
- `conditions` (MeterConditions, optional, nullable)
- `meter_value` (InvoiceLineMeterValue, optional, nullable)
- `details` (PricingItemSummaryPriceDetails, optional, nullable)
- `sub_lines` (list of InvoiceSubLine, optional, nullable)
- `applicable_for_clauses` (list of string, optional, nullable) — The clauses of the subscriptions on this invoice that also apply to this line, only set when type == ONE_OFF

### WalletType

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `name` (string, optional)
- `reference` (string, optional)
- `status` (enum, optional, nullable)
  - Allowed values: `DRAFT`, `ACTIVE`, `INACTIVE`, `DEPRECATED`, `ARCHIVED`
- `type` (enum, optional, nullable)
  - Allowed values: `CREDIT`, `BALANCE`
- `credit` (WalletTypeCredit, optional)
- `balance` (WalletTypeBalance, optional)
- `created_at` (string, optional, nullable)
- `updated_at` (string, optional, nullable)

### AutoTopupConfig

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `wallet_id` (string, optional) — Resource ID of type WALLET
- `status` (enum, optional)
  - Allowed values: `ACTIVE`, `INACTIVE`
- `threshold` (AutoTopupThreshold, optional)
- `topup_amount` (Amount, optional)
- `pricing_plan_schedule_id` (string, optional) — Resource ID of type PRICING_PLAN_SCHEDULE
- `pricing_item_id` (string, optional) — Resource ID of type PRICING_ITEM
- `payment_method_id` (string, optional) — Resource ID of type PAYMENT_METHOD
- `created_at` (string, optional, nullable)
- `updated_at` (string, optional, nullable)

### WalletBalanceValue

- `credits` (Credits, optional, nullable)
- `amount` (Amount, optional, nullable)

### WalletCustomerBalanceDetail

- `customer_id` (string, optional, nullable) — The ID of the customer whose usage the reserved balance is attributed to.
- `reserved_balance` (WalletBalanceValue, optional, nullable) — This customer's share of the reserved balance of the wallet.
- `balance` (WalletBalanceValue, optional, nullable) — The balance held for this customer alone.
- `over_granted` (WalletBalanceValue, optional, nullable) — The part of this customer's balance its period was not entitled to.

### PricingItem

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `original_pricing_item_id` (string, optional, nullable)
- `original_pricing_item` (PricingItemOriginalPricingItem, optional, nullable) — This property creates a circular reference in the `PricingItem` schema. If you experience any issues with OpenAPI tools related to these circular references, you can try removing this property from the specification.
- `override` (enum, optional, nullable)
  - Allowed values: `ALL`, `SPECIFIC`
- `product_item_ids` (list of string, optional)
- `product_items` (list of ProductItem, optional, nullable)
- `configs` (list of PricingItemConfig, optional, nullable)
- `pricing_currency_configs` (list of PricingItemPricingCurrencyConfig, optional, nullable)
- `billing_period_configs` (list of PricingItemBillingPeriodConfig, optional, nullable)
- `display_order` (integer, optional, nullable)

### FeatureResourceReference

- `id` (string, optional, nullable) — The ID of the feature.
- `reference` (string, optional) — The reference of the feature.

### AgentContext

- `guidance` (string, optional, nullable) — Free-text guidance for AI agents on how to interpret and use this resource.

### ProductItem

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `product_id` (string, optional, nullable) — The resource ID of the product, that belongs to the product item.
- `product` (Product, optional, nullable)
- `name` (string, optional, nullable)
- `status` (enum, optional, nullable)
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`
- `reference` (string, optional)
- `description` (string, optional, nullable)
- `type` (enum, optional, nullable) — The type of the product item.
  - Allowed values: `REVENUE`, `DEDUCTION`
- `model_type` (enum, optional, nullable)
  - Allowed values: `USAGE_BASED`, `USAGE_BASED_CONVERSION`, `RECURRING`, `ONE_OFF`, `PER_SEAT`, `CREDITS`
- `usage_based` (ProductItemUsageBased, optional) — Additional settings in case of a USAGE_BASED type.
- `credits` (ProductItemCredits, optional) — Additional settings in case of a CREDITS type.
- `meter_value_calculation` (MeterValueCalculation, optional, nullable)
- `tax_category` (enum, optional, nullable) — The default tax category applied to the product item.
  - Allowed values: `STANDARD`, `NO_TAX`, `EXEMPT`
- `display_order` (integer, optional, nullable)
- `unit_name` (UnitName, optional)
- `custom_fields` (list of CustomFieldValue, optional, nullable) — Custom fields associated to this product item
- `customer_id` (string, optional, nullable)
- `agent_context` (AgentContext, optional) — Context for AI agents about this product item. Intended for agents, not for customer-facing output.
- `meter_value_calculation_id` (string, optional, nullable, deprecated) — The linked meter value calculation, in case of a USAGE_BASED charge type.
- `report_meter_value_calculation_ids` (list of string, optional, nullable, deprecated) — Optional reporting meter value calculations, in case of a USAGE_BASED charge type.

### InvoiceLineCouponData

- `coupon_id` (string, optional)
- `promotion_code_id` (string, optional, nullable)

### MeterConditions

- `name` (string, optional, nullable)
- `expression` (MeterConditionExpression, optional)
- `meter_properties` (list of MeterPropertyCondition, optional, nullable, deprecated)

### InvoiceLineMeterValue

- `reference` (string, optional)
- `type` (string, optional)
- `number` (string, optional, nullable)
- `amount` (Amount, optional)

### PricingItemSummaryPriceDetails

- `amount` (Amount, optional)
- `pricing_currency` (string, optional, nullable)
- `pricing_amount` (Amount, optional)
- `conversion` (PricingItemSummaryPriceDetailsConversion, optional)
- `band` (PricingItemSummaryPriceDetailsBand, optional)
- `meter_value` (PricingItemSummaryMeterValue, optional)
- `tiering_meter_value` (PricingItemSummaryMeterValue, optional)
- `price_bound` (string, optional, nullable)
- `meter_values` (list of IngestDataSummary, optional)
- `report_meter_values` (list of ReportIngestDataSummary, optional)
- `description` (string, optional, nullable)
- `used_exchange_rates` (list of UsedExchangeRate, optional, nullable)
- `included_volume_details` (PricingItemSummaryIncludedVolumeDetails, optional)
- `wallet_balance_details` (PricingItemSummaryWalletBalanceDetails, optional)
- `wallet_balances` (list of PricingItemSummaryWalletBalance, optional, nullable)
- `used_wallet_grants` (list of UsedWalletGrantDetail, optional, nullable)
- `split_pricing` (PricingItemConfigSplitPricing, optional, nullable)
- `meter_value_share_of_total` (string, optional, nullable)
- `meter_value_share_of_processing_only_customer_total` (string, optional, nullable)

### InvoiceSubLine

- `sub_line_order` (integer, optional)
- `details` (PricingItemSummaryPriceDetails, optional)
- `description` (string, optional, nullable)
- `processing_only_customer_id` (string, optional, nullable)
- `type` (enum, optional, nullable)
  - Allowed values: `USAGE_BASED_CONVERSION`
- `usage_based_conversion` (InvoiceSubLineUsageBasedConversion, optional)
- `processing_only_customer_resource_id` (string, optional, nullable, deprecated)

### WalletTypeCredit

- `grant_type` (enum, optional)
  - Allowed values: `CREDITS`, `AMOUNT`
- `amount_grant` (WalletTypeCreditAmountGrant, optional)
- `credits_grant` (WalletTypeCreditCreditsGrant, optional)

### WalletTypeBalance

- `default_currency` (string, optional) — The default currency for the wallet.

### AutoTopupThreshold

- `amount` (Amount, optional)
- `credits` (Credits, optional)

### Credits

- `quantity` (string, optional)
- `credit_type_id` (string, optional) — Resource ID of type CREDIT_TYPE
- `credit_type` (CreditType, optional, nullable)

### PricingItemOriginalPricingItem

This property creates a circular reference in the `PricingItem` schema. If you experience any issues with OpenAPI tools related to these circular references, you can try removing this property from the specification.

### PricingItemConfig

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable) — Resource ID of type PRICING_ITEM_CONFIG
- `original_pricing_item_config_id` (string, optional, nullable)
- `original_pricing_item_config` (PricingItemConfigOriginalPricingItemConfig, optional, nullable) — This property creates a circular reference in the `PricingItemConfig` schema. If you experience any issues with OpenAPI tools related to these circular references, you can try removing this property from the specification.
- `details` (PricingItemConfigDetails, optional)
- `billing_period` (Period, optional)
- `pricing_period` (Period, optional)
- `default_included_volume` (PricingItemConfigMeterValueIncludedVolume, optional)
- `default_seats_value` (PricingItemConfigMeterValue, optional)
- `default_units` (PricingItemConfigMeterValue, optional) — The default number of units billed for a One Off product item priced `FLAT` with a per-unit amount. Set to 1 when not provided.
- `conditions` (PricingItemConfigConditions, optional)
- `tiering_conditions` (MeterConditions, optional) — Conditions that filter for which `TIERING` events this pricing item config is applied. Only the `expression` is supported here; the deprecated `meter_properties` field is not allowed.
- `order` (integer, optional, nullable)
- `billing_in_advance` (boolean, optional, nullable)
- `volume_group_reference` (string, optional, nullable)
- `top_up` (PricingItemConfigTopUp, optional)
- `split_pricing` (PricingItemConfigSplitPricing, optional)
- `on_demand` (boolean, optional, nullable)
- `wallet_grants` (list of PricingItemConfigWalletGrant, optional, nullable)
- `type` (enum, optional, nullable, deprecated)
  - Allowed values: `FLAT`, `FLAT_TOP_UP`, `TIERED`, `TIERED_TOP_UP`, `TOP_TIERED`, `STAIR_STEP`, `STAIR_STEP_TOP_UP`, `FIXED`, `FLEXIBLE`, `PASS_THROUGH`, `NONE`
- `pricing_type` (enum, optional, nullable, deprecated)
  - Allowed values: `FLAT`, `FLAT_TOP_UP`, `TIERED`, `TIERED_TOP_UP`, `TOP_TIERED`, `STAIR_STEP`, `STAIR_STEP_TOP_UP`, `FIXED`, `FLEXIBLE`, `PASS_THROUGH`, `NONE`
- `bands` (list of PricingItemConfigBand, optional, deprecated)

### PricingItemPricingCurrencyConfig

- `currency` (enum, optional, nullable)
  - Allowed values: `AED`, `AFN`, `ALL`, `AMD`, `ANG`, `AOA`, `ARS`, `AUD`, `AWG`, `AZN`, `BAM`, `BBD`, `BDT`, `BGN`, `BHD`, `BIF`, `BMD`, `BND`, `BOB`, `BRL`, `BSD`, `BTN`, `BWP`, `BYN`, `BZD`, `CAD`, `CDF`, `CHF`, `CLF`, `CLP`, `CNY`, `COP`, `CRC`, `CUC`, `CUP`, `CVE`, `CZK`, `DJF`, `DKK`, `DOP`, `DZD`, `EGP`, `ERN`, `ETB`, `EUR`, `FJD`, `FKP`, `GBP`, `GEL`, `GHS`, `GIP`, `GMD`, `GNF`, `GTQ`, `GYD`, `HKD`, `HNL`, `HRK`, `HTG`, `HUF`, `IDR`, `ILS`, `INR`, `IQD`, `IRR`, `ISK`, `JMD`, `JOD`, `JPY`, `KES`, `KGS`, `KHR`, `KMF`, `KPW`, `KRW`, `KWD`, `KYD`, `KZT`, `LAK`, `LBP`, `LKR`, `LRD`, `LSL`, `LYD`, `MAD`, `MDL`, `MGA`, `MKD`, `MMK`, `MNT`, `MOP`, `MRO`, `MRU`, `MUR`, `MVR`, `MWK`, `MXN`, `MXV`, `MYR`, `MZN`, `NAD`, `NGN`, `NIO`, `NOK`, `NPR`, `NZD`, `OMR`, `PAB`, `PEN`, `PGK`, `PHP`, `PKR`, `PLN`, `PYG`, `QAR`, `RON`, `RSD`, `RUB`, `RWF`, `SAR`, `SBD`, `SCR`, `SDG`, `SEK`, `SGD`, `SHP`, `SLE`, `SOS`, `SRD`, `SSP`, `STN`, `SVC`, `SYP`, `SZL`, `THB`, `TJS`, `TMT`, `TND`, `TOP`, `TRY`, `TTD`, `TWD`, `TZS`, `UAH`, `UGX`, `USD`, `USN`, `UYI`, `UYU`, `UZS`, `VEF`, `VES`, `VND`, `VUV`, `WST`, `XAF`, `XAG`, `XAU`, `XBA`, `XBB`, `XBC`, `XBD`, `XCD`, `XDR`, `XOF`, `XPD`, `XPF`, `XPT`, `XSU`, `XTS`, `XUA`, `XXX`, `YER`, `ZAR`, `ZMW`, `ZWL`
- `configs` (list of PricingItemConfig, optional, nullable)
- `billing_period_configs` (list of PricingItemBillingPeriodConfig, optional, nullable)
- `fallback_currency` (enum, optional, nullable)
  - Allowed values: `AED`, `AFN`, `ALL`, `AMD`, `ANG`, `AOA`, `ARS`, `AUD`, `AWG`, `AZN`, `BAM`, `BBD`, `BDT`, `BGN`, `BHD`, `BIF`, `BMD`, `BND`, `BOB`, `BRL`, `BSD`, `BTN`, `BWP`, `BYN`, `BZD`, `CAD`, `CDF`, `CHF`, `CLF`, `CLP`, `CNY`, `COP`, `CRC`, `CUC`, `CUP`, `CVE`, `CZK`, `DJF`, `DKK`, `DOP`, `DZD`, `EGP`, `ERN`, `ETB`, `EUR`, `FJD`, `FKP`, `GBP`, `GEL`, `GHS`, `GIP`, `GMD`, `GNF`, `GTQ`, `GYD`, `HKD`, `HNL`, `HRK`, `HTG`, `HUF`, `IDR`, `ILS`, `INR`, `IQD`, `IRR`, `ISK`, `JMD`, `JOD`, `JPY`, `KES`, `KGS`, `KHR`, `KMF`, `KPW`, `KRW`, `KWD`, `KYD`, `KZT`, `LAK`, `LBP`, `LKR`, `LRD`, `LSL`, `LYD`, `MAD`, `MDL`, `MGA`, `MKD`, `MMK`, `MNT`, `MOP`, `MRO`, `MRU`, `MUR`, `MVR`, `MWK`, `MXN`, `MXV`, `MYR`, `MZN`, `NAD`, `NGN`, `NIO`, `NOK`, `NPR`, `NZD`, `OMR`, `PAB`, `PEN`, `PGK`, `PHP`, `PKR`, `PLN`, `PYG`, `QAR`, `RON`, `RSD`, `RUB`, `RWF`, `SAR`, `SBD`, `SCR`, `SDG`, `SEK`, `SGD`, `SHP`, `SLE`, `SOS`, `SRD`, `SSP`, `STN`, `SVC`, `SYP`, `SZL`, `THB`, `TJS`, `TMT`, `TND`, `TOP`, `TRY`, `TTD`, `TWD`, `TZS`, `UAH`, `UGX`, `USD`, `USN`, `UYI`, `UYU`, `UZS`, `VEF`, `VES`, `VND`, `VUV`, `WST`, `XAF`, `XAG`, `XAU`, `XBA`, `XBB`, `XBC`, `XBD`, `XCD`, `XDR`, `XOF`, `XPD`, `XPF`, `XPT`, `XSU`, `XTS`, `XUA`, `XXX`, `YER`, `ZAR`, `ZMW`, `ZWL`

### PricingItemBillingPeriodConfig

- `billing_period` (Period, optional)
- `configs` (list of PricingItemConfig, optional, nullable)

### ProductItemUsageBased

- `meter_value_calculation_id` (string, optional, nullable) — The linked meter value calculation
- `meter_value_calculation` (MeterValueCalculation, optional, nullable)
- `tiering_meter_value_calculation_id` (string, optional, nullable) — The optional alternative linked meter value calculation for tiering
- `tiering_meter_value_calculation` (MeterValueCalculation, optional, nullable)
- `report_meter_value_calculation_ids` (list of string, optional, nullable) — Optional reporting meter value calculations.
- `conditions` (MeterConditions, optional) — Optional conditions.

### ProductItemCredits

- `credit_type_id` (string, optional, nullable) — The linked meter value calculation
- `credit_type` (CreditType, optional, nullable)

### MeterValueCalculation

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `calculation_type` (enum, optional, nullable) — The type of calculation used for this billable metric.
  - Allowed values: `SUM`, `MAX`, `MIN`, `AVERAGE`, `UNIQUE`
- `persist` (boolean, optional, nullable) — Indicate if the data of the billable metric must be persisted to the next billing period of the schedule (default is false).
- `meter_id` (string, optional, nullable) — The ID of the meter.
- `meter` (Meter, optional, nullable)
- `meter_value_id` (string, optional, nullable) — The ID of the meter value.
- `meter_value` (MeterValue, optional, nullable)
- `meter_property_id` (string, optional, nullable) — The ID of the meter property.
- `meter_property` (MeterProperty, optional, nullable)

### UnitName

- `singular` (string, optional)
- `plural` (string, optional, nullable)

### MeterConditionExpression

- `operator` (enum, optional)
  - Allowed values: `AND`, `OR`, `XOR`
- `operands` (list of MeterConditionOperand, optional, nullable)

### MeterPropertyCondition

- `id` (string, optional, nullable) — Resource ID of type METER_PROPERTY
- `reference` (string, optional, nullable)
- `meter_property` (MeterProperty, optional, nullable)
- `value` (string, optional, nullable)
- `values` (list of string, optional, nullable)
- `meter_property_variable_id` (string, optional, nullable) — Resource ID of type METER_PROPERTY_VARIABLE
- `meter_property_variable` (MeterPropertyVariable, optional, nullable)
- `comparator` (enum, optional)
  - Allowed values: `EQUALS`, `NOT_EQUALS`, `IN`, `NOT_IN`, `GREATER_THAN`, `GREATER_THAN_OR_EQUALS`, `LESS_THAN`, `LESS_THAN_OR_EQUALS`, `EMPTY`, `NOT_EMPTY`, `CONTAINS`, `NOT_CONTAINS`

### PricingItemSummaryPriceDetailsConversion

- `credits` (Credits, optional)
- `convert_from_meter_value_id` (string, optional)

### PricingItemSummaryPriceDetailsBand

- `amount` (Amount, optional)
- `percentage` (string, optional, nullable)
- `credits` (Credits, optional)
- `maximum_amount` (Amount, optional)
- `minimum_amount` (Amount, optional)
- `maximum_number` (string, optional, nullable)
- `minimum_number` (string, optional, nullable)
- `block_size` (PricingItemConfigMeterValue, optional)
- `tier_lower_bound` (PricingItemConfigMeterValue, optional)
- `tier_top_bound` (PricingItemConfigMeterValue, optional)
- `volume_share` (string, optional, nullable)
- `included_volume` (PricingItemConfigMeterValue, optional)

### PricingItemSummaryMeterValue

- `id` (string, optional, nullable) — Resource ID of type METER_VALUE
- `reference` (string, optional, nullable)
- `number` (string, optional, nullable) — Number value of the meter value, will be set when type == NUMBER
- `amount` (Amount, optional) — Amount value of the meter value, will be set when type == AMOUNT
- `count` (string, optional, nullable)
- `ratio` (string, optional, nullable)
- `type` (enum, optional, nullable) — Type of the meter value
  - Allowed values: `NUMBER`, `AMOUNT`

### IngestDataSummary

- `number` (string, optional, nullable)
- `amount` (Amount, optional)
- `amount_in_pricing_currency` (Amount, optional)
- `count` (long, optional)
- `ratio` (string, optional, nullable)

### ReportIngestDataSummary

- `meter_value_calculation_id` (string, optional)
- `number` (string, optional, nullable)
- `amount` (Amount, optional)
- `amount_in_pricing_currency` (Amount, optional)
- `count` (string, optional, nullable)
- `ratio` (string, optional, nullable)

### PricingItemSummaryIncludedVolumeDetails

- `included_volume` (PricingItemSummaryMeterValue, optional)
- `available_included_volume` (PricingItemSummaryMeterValue, optional)
- `period_volume` (PricingItemSummaryMeterValue, optional)

### PricingItemSummaryWalletBalanceDetails

- `used_wallet_credits` (Credits, optional) — Deprecated, use `wallet_balances`. The credits that are used from the wallet
- `left_wallet_credits` (Credits, optional) — Deprecated, use `wallet_balances`. The credits still left after this charge, out of those this charge could be paid from. This can be used in case there will come more usage
- `available_wallet_credits` (Credits, optional) — Deprecated, use `wallet_balances`. The credits this charge could be paid from, before it was paid. The credits available can be more than used, in case credits are reserved/ used for other charges, or in case the usage is less than available.

### PricingItemSummaryWalletBalance

- `wallet_id` (string, optional, nullable)
- `used_balance` (WalletBalanceValue, optional, nullable) — What this charge took out of the wallet. A wallet that pays in money reports a net amount: it reduces the taxable base of the charge, because the tax was already charged when the wallet was funded.
- `left_balance` (WalletBalanceValue, optional, nullable) — What is still left on this wallet after the charge, out of the balance it could be paid from. This can be used in case there will come more usage
- `available_balance` (WalletBalanceValue, optional, nullable) — The balance this charge could be paid from, before it was paid. What is available can be more than what is used, in case the balance is reserved/ used for other charges, or in case the usage is less than available.

### UsedWalletGrantDetail

- `wallet_id` (string, optional, nullable)
- `wallet_grant_id` (string, optional, nullable)
- `used_balance` (WalletBalanceValue, optional, nullable) — What this charge took out of this grant.
- `balance_at` (string, optional, nullable) — The date the balance was read at, which is the start of the period the charge belongs to.
- `paid_at` (string, optional, nullable) — The date the grant is drawn on.

### PricingItemConfigSplitPricing

- `meter_properties` (list of MeterPropertySplitPricing, optional, nullable)

### InvoiceSubLineUsageBasedConversion

- `conditions` (MeterConditions, optional)

### WalletTypeCreditAmountGrant

- `default_currency` (enum, optional) — The default currency for the wallet. Required when credit.grant_type is AMOUNT.
  - Allowed values: `AED`, `AFN`, `ALL`, `AMD`, `ANG`, `AOA`, `ARS`, `AUD`, `AWG`, `AZN`, `BAM`, `BBD`, `BDT`, `BGN`, `BHD`, `BIF`, `BMD`, `BND`, `BOB`, `BRL`, `BSD`, `BTN`, `BWP`, `BYN`, `BZD`, `CAD`, `CDF`, `CHF`, `CLF`, `CLP`, `CNY`, `COP`, `CRC`, `CUC`, `CUP`, `CVE`, `CZK`, `DJF`, `DKK`, `DOP`, `DZD`, `EGP`, `ERN`, `ETB`, `EUR`, `FJD`, `FKP`, `GBP`, `GEL`, `GHS`, `GIP`, `GMD`, `GNF`, `GTQ`, `GYD`, `HKD`, `HNL`, `HRK`, `HTG`, `HUF`, `IDR`, `ILS`, `INR`, `IQD`, `IRR`, `ISK`, `JMD`, `JOD`, `JPY`, `KES`, `KGS`, `KHR`, `KMF`, `KPW`, `KRW`, `KWD`, `KYD`, `KZT`, `LAK`, `LBP`, `LKR`, `LRD`, `LSL`, `LYD`, `MAD`, `MDL`, `MGA`, `MKD`, `MMK`, `MNT`, `MOP`, `MRO`, `MRU`, `MUR`, `MVR`, `MWK`, `MXN`, `MXV`, `MYR`, `MZN`, `NAD`, `NGN`, `NIO`, `NOK`, `NPR`, `NZD`, `OMR`, `PAB`, `PEN`, `PGK`, `PHP`, `PKR`, `PLN`, `PYG`, `QAR`, `RON`, `RSD`, `RUB`, `RWF`, `SAR`, `SBD`, `SCR`, `SDG`, `SEK`, `SGD`, `SHP`, `SLE`, `SOS`, `SRD`, `SSP`, `STN`, `SVC`, `SYP`, `SZL`, `THB`, `TJS`, `TMT`, `TND`, `TOP`, `TRY`, `TTD`, `TWD`, `TZS`, `UAH`, `UGX`, `USD`, `USN`, `UYI`, `UYU`, `UZS`, `VEF`, `VES`, `VND`, `VUV`, `WST`, `XAF`, `XAG`, `XAU`, `XBA`, `XBB`, `XBC`, `XBD`, `XCD`, `XDR`, `XOF`, `XPD`, `XPF`, `XPT`, `XSU`, `XTS`, `XUA`, `XXX`, `YER`, `ZAR`, `ZMW`, `ZWL`
- `tax_category` (enum, optional) — The tax category that scopes what the wallet can be spent on. Required when credit.grant_type is AMOUNT. Can only be changed while no wallet of this type exists.
  - Allowed values: `STANDARD`, `NO_TAX`, `EXEMPT`

### WalletTypeCreditCreditsGrant

- `credit_type_id` (string, optional) — The credit type for wallets of wallet type.

### CreditType

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `status` (enum, optional, nullable)
  - Allowed values: `DRAFT`, `ACTIVE`, `INACTIVE`, `DEPRECATED`, `ARCHIVED`
- `name` (string, optional)
- `description` (string, optional, nullable)
- `unit_name` (UnitName, optional)
- `created_at` (string, optional, nullable)
- `updated_at` (string, optional, nullable)

### PricingItemConfigOriginalPricingItemConfig

This property creates a circular reference in the `PricingItemConfig` schema. If you experience any issues with OpenAPI tools related to these circular references, you can try removing this property from the specification.

### PricingItemConfigDetails

- `billing_period` (Period, optional)
- `pricing_type` (enum, optional, nullable)
  - Allowed values: `FLAT`, `FLAT_TOP_UP`, `TIERED`, `TIERED_TOP_UP`, `TOP_TIERED`, `STAIR_STEP`, `STAIR_STEP_TOP_UP`, `FIXED`, `FLEXIBLE`, `PASS_THROUGH`, `NONE`
- `pricing_period` (Period, optional)
- `bands` (list of PricingItemConfigBand, optional)

### PricingItemConfigMeterValueIncludedVolume

- `number` (string, optional, nullable)
- `amount` (Amount, optional)
- `count` (string, optional, nullable)
- `reset_type` (string, optional, nullable)

### PricingItemConfigMeterValue

- `number` (string, optional, nullable)
- `amount` (Amount, optional)
- `count` (string, optional, nullable)

### PricingItemConfigConditions

- `name` (string, optional, nullable)
- `meter_properties` (list of MeterPropertyCondition, optional, nullable)
- `configs` (list of PricingItemConfigConditionsConfigsItems, optional, nullable)

### PricingItemConfigTopUp

- `rollover` (boolean, optional, nullable)

### PricingItemConfigWalletGrant

- `wallet_type_id` (string, optional) — Resource ID of type WALLET_TYPE
- `wallet_type` (WalletType, optional, nullable)
- `amount_grant` (PricingItemConfigWalletGrantAmountGrant, optional)
- `credits_grant` (PricingItemConfigWalletGrantCreditsGrant, optional)
- `expiry_policy` (PricingItemConfigWalletGrantExpiryPolicy, optional)
- `source` (enum, optional, nullable) — What the grant quantity is derived from. Defaults to FIXED. SEAT_POOL multiplies the fixed grant by the purchased seat count and grants it into the shared customer pool. PER_SEAT grants the fixed credits once per occupied seat, restricted to the customer holding that seat, and requires credits_grant.credits.
  - Allowed values: `FIXED`, `SEAT_POOL`, `PER_SEAT`

### PricingItemConfigBand

- `amount` (Amount, optional)
- `percentage` (string, optional, nullable)
- `credits` (Credits, optional)
- `fixed_amount` (Amount, optional)
- `maximum_amount` (Amount, optional)
- `minimum_amount` (Amount, optional)
- `maximum_number` (string, optional, nullable)
- `minimum_number` (string, optional, nullable)
- `block_size` (PricingItemConfigMeterValue, optional)
- `tier_top_bound` (PricingItemConfigMeterValue, optional)

### Meter

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `status` (enum, optional, nullable) — The status of the meter indicating the activity of the meter and the ability to update properties.
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`
- `meter_values` (list of MeterMeterValue, optional, nullable) — The values used as input to calculate billable units, used in the meter.
- `meter_properties` (list of MeterMeterProperty, optional, nullable) — The properties that provide information to give context to an event, used in the meter.

### MeterValue

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `status` (enum, optional, nullable) — The status of the meter value indicating the activity and the ability to update properties.
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`
- `type` (enum, optional, nullable) — The type of the meter value.
  - Allowed values: `NUMBER`, `AMOUNT`

### MeterProperty

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `status` (enum, optional) — The status of the meter property indicating the activity and the ability to update properties.
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`
- `type` (enum, optional, nullable) — The type of the meter property.
  - Allowed values: `NUMBER`, `ENUM`, `STRING`
- `enum_values` (list of string, optional, nullable) — The list of available ENUM values.

### MeterConditionOperand

- `meter_property` (MeterPropertyCondition, optional)
- `expression` (MeterConditionOperandExpression, optional, nullable)

### MeterPropertyVariable

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `meter_property_id` (string, optional, nullable) — The meter property whose values this variable lists. Set on create only.
- `meter_property_reference` (string, optional, nullable) — Alternative to meter_property_id on create.
- `type` (enum, optional, nullable)
  - Allowed values: `LIST`
- `status` (enum, optional, nullable)
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`
- `values` (list of string, optional, nullable) — The initial values, on create only. Edit them afterwards through the values endpoint.
- `value_count` (integer, optional, nullable)
- `created_at` (string, optional, nullable)
- `updated_at` (string, optional, nullable)

### MeterPropertySplitPricing

- `id` (string, optional, nullable) — Resource ID of type METER_PROPERTY
- `reference` (string, optional, nullable)
- `value` (string, optional, nullable)
- `meter_property` (MeterProperty, optional, nullable)

### PricingItemConfigConditionsConfigsItems

### PricingItemConfigWalletGrantAmountGrant

- `amount` (Amount, optional)
- `percentage` (string, optional, nullable)

### PricingItemConfigWalletGrantCreditsGrant

- `credits` (Credits, optional)
- `conversion` (PricingItemConfigWalletGrantCreditsGrantConversion, optional)

### PricingItemConfigWalletGrantExpiryPolicy

- `expiry_period` (Period, optional)

### MeterMeterValue

- `id` (string, optional, nullable) — Resource ID of type METER_VALUE
- `object` (MeterValue, optional, nullable)
- `reference` (string, optional, nullable)
- `required` (boolean, optional, nullable)

### MeterMeterProperty

- `id` (string, optional, nullable) — Resource ID of type METER_PROPERTY
- `object` (MeterProperty, optional, nullable)
- `reference` (string, optional, nullable)
- `required` (boolean, optional, nullable)

### MeterConditionOperandExpression

### PricingItemConfigWalletGrantCreditsGrantConversion

- `credit_type_id` (string, optional)
- `rate` (string, optional)

## Examples

**Response**

```json
{
  "data": [
    {
      "object_type": "string",
      "id": "string",
      "reference": "string",
      "type": "INGEST",
      "customer_id": "string",
      "customer_reference": "string",
      "customer": {
        "object_type": "string",
        "id": "string",
        "created_at": "string",
        "parent_customer_id": "string",
        "parent_customer_ids": [
          "string"
        ],
        "reference": "string",
        "status": "DRAFT",
        "timezone": "string",
        "type": "ORGANIZATION",
        "email": "string",
        "notification_preferences": [
          {
            "type": "INVOICE",
            "channels": [
              {
                "type": "EMAIL",
                "enabled": true
              }
            ]
          }
        ],
        "locale": "string",
        "individual": {
          "name": {
            "first_name": "string",
            "last_name": "string",
            "infix": "string"
          },
          "residential_address": {
            "line1": "string",
            "line2": "string",
            "city": "string",
            "postal_code": "string",
            "state": "string",
            "country": "AD"
          }
        },
        "organization": {
          "legal_name": "string",
          "tax_id": "string",
          "tax_ids": [
            {
              "id": "string",
              "type": "GENERIC_TAX_ID",
              "display_name": "string",
              "tax_id_validation_result": {
                "id": "string",
                "validation_date": "string",
                "source": "string",
                "valid": "VALID",
                "message": "string"
              }
            }
          ],
          "registration_number": "string",
          "tax_exempt": true,
          "tax_exempt_note": "string",
          "registered_address": {
            "line1": "string",
            "line2": "string",
            "city": "string",
            "postal_code": "string",
            "state": "string",
            "country": "AD"
          },
          "tax_registrations": [
            {
              "id": "string",
              "description": "string",
              "tax_id": "string",
              "tax_ids": [
                {
                  "id": "string",
                  "type": "GENERIC_TAX_ID",
                  "display_name": "string",
                  "tax_id_validation_result": {
                    "id": "string",
                    "validation_date": "string",
                    "source": "string",
                    "valid": "VALID",
                    "message": "string"
                  }
                }
              ],
              "registration_number": "string",
              "registered_address": {
                "line1": "string",
                "line2": "string",
                "city": "string",
                "postal_code": "string",
                "state": "string",
                "country": "AD"
              }
            }
          ]
        },
        "custom_fields": [
          {
            "id": "string",
            "reference": "string",
            "value": "string",
            "values": [
              "string"
            ],
            "integration_details": {
              "id": "string",
              "reference": "string",
              "payment_gateway_variant": "ADYEN",
              "adyen": {
                "recurring_detail_reference": "string"
              },
              "stripe": {
                "payment_method_id": "string"
              }
            },
            "integration_id": "string"
          }
        ],
        "pricing_plan_subscription_selector": {
          "data": [
            {
              "field": "BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY",
              "value": "string"
            }
          ],
          "rules": [
            {
              "field": "BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY",
              "type": "EQUALS"
            }
          ],
          "filters": [
            {
              "field": "BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY",
              "type": "EQUALS",
              "value": "string"
            }
          ],
          "fallback": "LATEST"
        },
        "linked_integrations": [
          {
            "id": "string",
            "link_details": [
              {
                "url": "string",
                "custom_field_name": "string"
              }
            ]
          }
        ],
        "roles": [
          "DEFAULT"
        ],
        "seller_details": {
          "default_billing_entity_id": "string"
        },
        "processing_only": true
      },
      "meter_id": "string",
      "meter_reference": "string",
      "pricing_plan_subscription_id": "string",
      "pricing_plan_subscription_reference": "string",
      "pricing_plan_subscription_selector": {
        "data": [
          {
            "field": "BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY",
            "value": "string"
          }
        ],
        "rules": [
          {
            "field": "BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY",
            "type": "EQUALS"
          }
        ],
        "filters": [
          {
            "field": "BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY",
            "type": "EQUALS",
            "value": "string"
          }
        ],
        "fallback": "LATEST"
      },
      "timestamp": "2024-01-15T09:30:00Z",
      "created_at": "string",
      "meter_properties": [
        {
          "id": "string",
          "reference": "string",
          "value": "string",
          "dynamic_validation_settings": {
            "type": "NUMBER",
            "required": true
          }
        }
      ],
      "meter_values": [
        {
          "id": "string",
          "reference": "string",
          "number": "string",
          "amount": {
            "quantity": "string",
            "currency": "AED"
          },
          "count": "string",
          "dynamic_validation_settings": {
            "type": "NUMBER",
            "required": true
          }
        }
      ],
      "cost_prediction": {
        "response": "OK",
        "status": "READY",
        "details": [
          {
            "customer_id": "string",
            "invoice_id": "string",
            "amount_excluding_tax": {
              "quantity": "string",
              "currency": "AED"
            },
            "amount_including_tax": {
              "quantity": "string",
              "currency": "AED"
            },
            "tax_summary": {
              "base_amount": {
                "quantity": "string",
                "currency": "AED"
              },
              "tax_amount": {
                "quantity": "string",
                "currency": "AED"
              },
              "total_amount": {
                "quantity": "string",
                "currency": "AED"
              },
              "local_amounts": {
                "base_amount": {
                  "quantity": "string",
                  "currency": "AED"
                },
                "tax_amount": {
                  "quantity": "string",
                  "currency": "AED"
                },
                "total_amount": {
                  "quantity": "string",
                  "currency": "AED"
                },
                "used_exchange_rate": {
                  "currency": "string",
                  "base_currency": "string",
                  "rate_timestamp": "string",
                  "rate": "string",
                  "source": "string"
                },
                "display": true
              },
              "notes": [
                "string"
              ],
              "country_code": "string"
            },
            "periods": [
              {
                "period_order": 1,
                "amount_excluding_tax": {
                  "quantity": "string",
                  "currency": "AED"
                },
                "amount_including_tax": {
                  "quantity": "string",
                  "currency": "AED"
                },
                "billing_period": {
                  "type": "DAY",
                  "value": 1
                },
                "start_at": "string",
                "end_at": "string",
                "tax_categories": [
                  {
                    "base_amount": {
                      "quantity": "string",
                      "currency": "AED"
                    },
                    "tax_amount": {
                      "quantity": "string",
                      "currency": "AED"
                    },
                    "total_amount": {
                      "quantity": "string",
                      "currency": "AED"
                    },
                    "category": "string",
                    "local_amounts": {
                      "base_amount": {
                        "quantity": "string",
                        "currency": "AED"
                      },
                      "tax_amount": {
                        "quantity": "string",
                        "currency": "AED"
                      },
                      "total_amount": {
                        "quantity": "string",
                        "currency": "AED"
                      },
                      "used_exchange_rate": {
                        "currency": "string",
                        "base_currency": "string",
                        "rate_timestamp": "string",
                        "rate": "string",
                        "source": "string"
                      },
                      "display": true
                    },
                    "notes": [
                      "string"
                    ],
                    "rates": [
                      {
                        "name": "string",
                        "percentage": "string",
                        "tax_amount": {
                          "quantity": "string",
                          "currency": "AED"
                        }
                      }
                    ],
                    "percentage": "string",
                    "name": "string"
                  }
                ],
                "groups": [
                  {
                    "group_order": 1,
                    "amount_excluding_tax": {
                      "quantity": "string",
                      "currency": "AED"
                    },
                    "amount_including_tax": {
                      "quantity": "string",
                      "currency": "AED"
                    },
                    "billing_period": {
                      "type": "DAY",
                      "value": 1
                    },
                    "start_at": "string",
                    "end_at": "string",
                    "type": "string",
                    "product_category": {
                      "object_type": "string",
                      "id": "string",
                      "name": "string",
                      "reference": "string",
                      "description": "string",
                      "tax_category": "STANDARD",
                      "display_order": 1,
                      "customer_id": "string"
                    },
                    "products": [
                      {
                        "object_type": "string",
                        "id": "string",
                        "category_id": "string",
                        "category": {
                          "object_type": "string",
                          "id": "string",
                          "name": "string",
                          "reference": "string",
                          "description": "string",
                          "tax_category": "STANDARD",
                          "display_order": 1,
                          "customer_id": "string"
                        },
                        "parent_product_id": "string",
                        "name": "string",
                        "reference": "string",
                        "description": "string",
                        "status": "DRAFT",
                        "product_type": "DEFAULT",
                        "tax_category": "STANDARD",
                        "features": [
                          {
                            "id": "string",
                            "reference": "string"
                          }
                        ],
                        "custom_fields": [
                          {
                            "id": "string",
                            "reference": "string",
                            "value": "string",
                            "values": [
                              "string"
                            ],
                            "integration_details": {
                              "id": "string",
                              "reference": "string",
                              "payment_gateway_variant": "ADYEN",
                              "adyen": {
                                "recurring_detail_reference": "string"
                              },
                              "stripe": {
                                "payment_method_id": "string"
                              }
                            },
                            "integration_id": "string"
                          }
                        ],
                        "display_order": 1,
                        "linked_integrations": [
                          {
                            "id": "string",
                            "link_details": [
                              {
                                "url": "string",
                                "custom_field_name": "string"
                              }
                            ]
                          }
                        ],
                        "billing_entity_id": "string",
                        "customer_id": "string",
                        "agent_context": {
                          "guidance": "string"
                        }
                      }
                    ],
                    "pricing": {
                      "id": "string",
                      "name": "string"
                    },
                    "description": "string",
                    "pricing_plan_subscription_id": "string",
                    "pricing_plan_schedule_id": "string",
                    "forwarded_from_customer_id": "string",
                    "tax_categories": [
                      {
                        "base_amount": {
                          "quantity": "string",
                          "currency": "AED"
                        },
                        "tax_amount": {
                          "quantity": "string",
                          "currency": "AED"
                        },
                        "total_amount": {
                          "quantity": "string",
                          "currency": "AED"
                        },
                        "category": "string",
                        "local_amounts": {
                          "base_amount": {
                            "quantity": "string",
                            "currency": "AED"
                          },
                          "tax_amount": {
                            "quantity": "string",
                            "currency": "AED"
                          },
                          "total_amount": {
                            "quantity": "string",
                            "currency": "AED"
                          },
                          "used_exchange_rate": {
                            "currency": "string",
                            "base_currency": "string",
                            "rate_timestamp": "string",
                            "rate": "string",
                            "source": "string"
                          },
                          "display": true
                        },
                        "notes": [
                          "string"
                        ],
                        "rates": [
                          {
                            "name": "string",
                            "percentage": "string",
                            "tax_amount": {
                              "quantity": "string",
                              "currency": "AED"
                            }
                          }
                        ],
                        "percentage": "string",
                        "name": "string"
                      }
                    ],
                    "lines": [
                      {
                        "id": "string",
                        "line_order": 1,
                        "description": "string",
                        "pricing_item_id": "string",
                        "pricing_item_config_id": "string",
                        "product_items": [
                          {
                            "object_type": "string",
                            "id": "string",
                            "product_id": "string",
                            "product": {
                              "object_type": "string",
                              "id": "string",
                              "category_id": "string",
                              "category": {
                                "object_type": "string",
                                "id": "string",
                                "name": "string",
                                "reference": "string",
                                "description": "string",
                                "tax_category": "STANDARD",
                                "display_order": 1,
                                "customer_id": "string"
                              },
                              "parent_product_id": "string",
                              "name": "string",
                              "reference": "string",
                              "description": "string",
                              "status": "DRAFT",
                              "product_type": "DEFAULT",
                              "tax_category": "STANDARD",
                              "features": [
                                {
                                  "id": "string",
                                  "reference": "string"
                                }
                              ],
                              "custom_fields": [
                                {
                                  "id": "string",
                                  "reference": "string",
                                  "value": "string",
                                  "values": [
                                    "string"
                                  ],
                                  "integration_details": {
                                    "id": "string",
                                    "reference": "string",
                                    "payment_gateway_variant": "ADYEN",
                                    "adyen": {
                                      "recurring_detail_reference": "string"
                                    },
                                    "stripe": {
                                      "payment_method_id": "string"
                                    }
                                  },
                                  "integration_id": "string"
                                }
                              ],
                              "display_order": 1,
                              "linked_integrations": [
                                {
                                  "id": "string",
                                  "link_details": [
                                    {
                                      "url": "string",
                                      "custom_field_name": "string"
                                    }
                                  ]
                                }
                              ],
                              "billing_entity_id": "string",
                              "customer_id": "string",
                              "agent_context": {
                                "guidance": "string"
                              }
                            },
                            "name": "string",
                            "status": "DRAFT",
                            "reference": "string",
                            "description": "string",
                            "type": "REVENUE",
                            "model_type": "USAGE_BASED",
                            "usage_based": {
                              "meter_value_calculation_id": "string",
                              "meter_value_calculation": {
                                "object_type": "string",
                                "id": "string",
                                "reference": "string",
                                "name": "string",
                                "description": "string",
                                "calculation_type": "SUM",
                                "persist": true,
                                "meter_id": "string",
                                "meter": {
                                  "object_type": "string",
                                  "id": "string",
                                  "reference": "string",
                                  "name": "string",
                                  "description": "string",
                                  "status": "DRAFT",
                                  "meter_values": [
                                    {
                                      "id": "string",
                                      "object": {
                                        "object_type": {},
                                        "id": {},
                                        "reference": {},
                                        "name": {},
                                        "description": {},
                                        "status": {},
                                        "type": {}
                                      },
                                      "required": true
                                    }
                                  ],
                                  "meter_properties": [
                                    {
                                      "id": "string",
                                      "object": {
                                        "object_type": {},
                                        "id": {},
                                        "reference": {},
                                        "name": {},
                                        "description": {},
                                        "status": {},
                                        "type": {},
                                        "enum_values": {}
                                      },
                                      "required": true
                                    }
                                  ]
                                },
                                "meter_value_id": "string",
                                "meter_value": {
                                  "object_type": "string",
                                  "id": "string",
                                  "reference": "string",
                                  "name": "string",
                                  "description": "string",
                                  "status": "DRAFT",
                                  "type": "NUMBER"
                                },
                                "meter_property_id": "string",
                                "meter_property": {
                                  "object_type": "string",
                                  "id": "string",
                                  "reference": "string",
                                  "name": "string",
                                  "description": "string",
                                  "status": "DRAFT",
                                  "type": "NUMBER",
                                  "enum_values": [
                                    "string"
                                  ]
                                }
                              },
                              "tiering_meter_value_calculation_id": "string",
                              "tiering_meter_value_calculation": {
                                "object_type": "string",
                                "id": "string",
                                "reference": "string",
                                "name": "string",
                                "description": "string",
                                "calculation_type": "SUM",
                                "persist": true,
                                "meter_id": "string",
                                "meter": {
                                  "object_type": "string",
                                  "id": "string",
                                  "reference": "string",
                                  "name": "string",
                                  "description": "string",
                                  "status": "DRAFT",
                                  "meter_values": [
                                    {
                                      "id": "string",
                                      "object": {
                                        "object_type": {},
                                        "id": {},
                                        "reference": {},
                                        "name": {},
                                        "description": {},
                                        "status": {},
                                        "type": {}
                                      },
                                      "required": true
                                    }
                                  ],
                                  "meter_properties": [
                                    {
                                      "id": "string",
                                      "object": {
                                        "object_type": {},
                                        "id": {},
                                        "reference": {},
                                        "name": {},
                                        "description": {},
                                        "status": {},
                                        "type": {},
                                        "enum_values": {}
                                      },
                                      "required": true
                                    }
                                  ]
                                },
                                "meter_value_id": "string",
                                "meter_value": {
                                  "object_type": "string",
                                  "id": "string",
                                  "reference": "string",
                                  "name": "string",
                                  "description": "string",
                                  "status": "DRAFT",
                                  "type": "NUMBER"
                                },
                                "meter_property_id": "string",
                                "meter_property": {
                                  "object_type": "string",
                                  "id": "string",
                                  "reference": "string",
                                  "name": "string",
                                  "description": "string",
                                  "status": "DRAFT",
                                  "type": "NUMBER",
                                  "enum_values": [
                                    "string"
                                  ]
                                }
                              },
                              "report_meter_value_calculation_ids": [
                                "string"
                              ],
                              "conditions": {
                                "name": "string",
                                "expression": {
                                  "operator": "AND",
                                  "operands": [
                                    {
                                      "meter_property": {
                                        "id": {},
                                        "reference": {},
                                        "meter_property": {},
                                        "value": {},
                                        "values": {},
                                        "meter_property_variable_id": {},
                                        "meter_property_variable": {},
                                        "comparator": {}
                                      },
                                      "expression": {}
                                    }
                                  ]
                                },
                                "meter_properties": [
                                  {
                                    "id": "string",
                                    "reference": "string",
                                    "meter_property": {
                                      "object_type": "string",
                                      "id": "string",
                                      "reference": "string",
                                      "name": "string",
                                      "description": "string",
                                      "status": "DRAFT",
                                      "type": "NUMBER",
                                      "enum_values": [
                                        "string"
                                      ]
                                    },
                                    "value": "string",
                                    "values": [
                                      "string"
                                    ],
                                    "meter_property_variable_id": "string",
                                    "meter_property_variable": {
                                      "object_type": "string",
                                      "id": "string",
                                      "reference": "string",
                                      "name": "string",
                                      "description": "string",
                                      "meter_property_id": "string",
                                      "type": "LIST",
                                      "status": "DRAFT",
                                      "value_count": 1,
                                      "created_at": "string",
                                      "updated_at": "string"
                                    },
                                    "comparator": "EQUALS"
                                  }
                                ]
                              }
                            },
                            "credits": {
                              "credit_type_id": "string",
                              "credit_type": {
                                "object_type": "string",
                                "id": "string",
                                "reference": "string",
                                "status": "DRAFT",
                                "name": "string",
                                "description": "string",
                                "unit_name": {
                                  "singular": "string",
                                  "plural": "string"
                                },
                                "created_at": "string",
                                "updated_at": "string"
                              }
                            },
                            "meter_value_calculation": {
                              "object_type": "string",
                              "id": "string",
                              "reference": "string",
                              "name": "string",
                              "description": "string",
                              "calculation_type": "SUM",
                              "persist": true,
                              "meter_id": "string",
                              "meter": {
                                "object_type": "string",
                                "id": "string",
                                "reference": "string",
                                "name": "string",
                                "description": "string",
                                "status": "DRAFT",
                                "meter_values": [
                                  {
                                    "id": "string",
                                    "object": {
                                      "object_type": "string",
                                      "id": "string",
                                      "reference": "string",
                                      "name": "string",
                                      "description": "string",
                                      "status": "DRAFT",
                                      "type": "NUMBER"
                                    },
                                    "required": true
                                  }
                                ],
                                "meter_properties": [
                                  {
                                    "id": "string",
                                    "object": {
                                      "object_type": "string",
                                      "id": "string",
                                      "reference": "string",
                                      "name": "string",
                                      "description": "string",
                                      "status": "DRAFT",
                                      "type": "NUMBER",
                                      "enum_values": [
                                        "string"
                                      ]
                                    },
                                    "required": true
                                  }
                                ]
                              },
                              "meter_value_id": "string",
                              "meter_value": {
                                "object_type": "string",
                                "id": "string",
                                "reference": "string",
                                "name": "string",
                                "description": "string",
                                "status": "DRAFT",
                                "type": "NUMBER"
                              },
                              "meter_property_id": "string",
                              "meter_property": {
                                "object_type": "string",
[...]
